% IMAGE SEGMENTATION 
  delete(get(0,'children')); clear
 
  %% Initalization
    A1=imread('CamA_DSC_0042bwS.jpg'); 
      AR=double(A1(:,:,1)); AR=AR(176:end,101:1700);
        [M,N]=size(AR);
      AR1=(AR-min(AR(:)))/(max(AR(:))-min(AR(:))); 
     figure(1);  
       imshow(AR1,'InitialMagnification','fit'), title('GIVEN IMAGE A')
 
       disp('Reference'); [Airef,Ajref]=ginput(1);
         Circle([Airef,Ajref,20],2,'w'); text(Airef+N/50,Ajref+M/50,'Reference','color','w')
       disp('Location A1'); [Ai(1),Aj(1)]=ginput(1);
         Circle([Ai(1),Aj(1),20],2,'w'); text(Ai(1)-N/20,Aj(1)-M/30,'C1','color','w')
       disp('Location A2'); [Ai(2),Aj(2)]=ginput(1);
         Circle([Ai(2),Aj(2),20],2,'w'); text(Ai(2)+N/30,Aj(2)-M/30,'C2','color','w')
       
    Ac1=imread('CamA_DSC_0040calibBWs.jpg'); 
      AR=double(Ac1(:,:,1)); AR=AR(176:end,101:1700);
        [s1,s2]=size(AR);
      ARc1=(AR-min(AR(:)))/(max(AR(:))-min(AR(:))); 
     figure(3);  
       imshow(ARc1,'InitialMagnification','fit'), title('CALIBRATION A')   
       
    A2=imread('CamB_DSC_0652bwS.jpg'); 
      AR=double(A2(:,:,1)); AR=AR(173:end,101:1700);
        [M,N]=size(AR);
      AR2=(AR-min(AR(:)))/(max(AR(:))-min(AR(:))); 
     figure(2);  
       imshow(AR2,'InitialMagnification','fit'), title('GIVEN IMAGE B')
       
       disp('Reference'); [Biref,Bjref]=ginput(1);
         Circle([Biref,Bjref,20],2,'w'); text(Biref-N/16,Bjref+M/15,'Reference','color','w')
       disp('Location B1'); [Bi(1),Bj(1)]=ginput(1);
         Circle([Bi(1),Bj(1),20],2,'w'); text(Bi(1)-N/20,Bj(1)-M/30,'C1','color','w')
       disp('Location B2'); [Bi(2),Bj(2)]=ginput(1);
         Circle([Bi(2),Bj(2),20],2,'w'); text(Bi(2)+N/30,Bj(2)-M/30,'C2','color','w')
 
    Ac2=imread('CamB_DSC_0650calibBWs.jpg'); 
      AR=double(Ac2(:,:,1)); AR=AR(173:end,101:1700);
        [s1,s2]=size(AR);
      ARc2=(AR-min(AR(:)))/(max(AR(:))-min(AR(:))); 
     figure(4);  
       imshow(ARc2,'InitialMagnification','fit'), title('CALIBRATION B')   

%% Pixel index transform
      Ajref=M-Ajref; Bjref=M-Bjref;
      for k=1:2
          Aj(k)=M-Aj(k); Bj(k)=M-Bj(k);
      end
       
%% Calibration
      distA=370;  distAh=96;  distAv=64;
        [Ah, Av]=calibration(distA,distAh,distAv);
      distB=610;  distBh=91;  distBv=64;
        [Bh, Bv]=calibration(distB,distBh,distBv);
      c=350;  a=590;  b=430;   
      
       alpha10=acos((b^2+c^2-a^2)/(2*b*c));
       beta10=acos((a^2+c^2-b^2)/(2*a*c));
       alpha20=0; if alpha10>pi/2, alpha20=pi; end
       beta20=0; if beta10>pi/2, beta20=pi; end
  
       xc0=b*cos(alpha10);
       yc0=b*sin(alpha10);
       zc0=0;
   
    %% Evaluation of coordinates
    for k=1:2
    % camera A
        alpha1(k)=alpha10-Ah*(Ai(k)-Airef)/N; % estimation from the camera A
        alpha2(k)=alpha20+Av*(Aj(k)-Ajref)/M; % estimation from the camera A
    % camera B
        beta1(k)=beta10+Bh*(Bi(k)-Biref)/N; % estimation from the camera B
        beta2(k)=beta20+Bv*(Bj(k)-Bjref)/M; % estimation from the camera B
    % x-y plane
        b1(k)=c*sin(beta1(k))/sin(pi-beta1(k)-alpha1(k));
        xc(k)=b1(k)*cos(alpha1(k));
        yc(k)=b1(k)*sin(alpha1(k));
    % x-z plane
        b2(k)=c*sin(beta2(k))/sin(pi-beta2(k)-alpha2(k));
        zc(k)=b2(k)*sin(alpha2(k));
    end
       
   Dist=sqrt((xc(2)-xc(1))^2+(yc(2)-yc(1))^2+(zc(2)-zc(1))^2)
   
 %% Coordinates of the reference point
    % x-y plane
        b1ref=c*sin(beta10)/sin(pi-beta10-alpha10);
        xcref=b1ref*cos(alpha10);
        ycref=b1ref*sin(alpha10);
    % x-z plane
        b2ref=c*sin(beta20+eps)/sin(pi-beta20-alpha20+eps);
        zcref=b2ref*sin(alpha20);
       
   %% Vizualization
   C=[xc' yc' zc'];
   figure(4); plot3(xcref, ycref,0,'ob',xc,yc,zc,'or',0,0,0,'s',c,0,0,'s');
   axis([-100 400 0 500 0 20]);
   line([xc; xc], [yc; yc], [zeros(1,length(xc)); zc],'color','k');
     hold on; line([0 c xcref 0],[0 0 ycref 0],[0 0 zcref 0]+0.1); 
              line([0 c xc(1) 0],[0 0 yc(1) 0],[0 0 zc(1) 0],'color','r');
              line([0 c xc(2) 0],[0 0 yc(2) 0],[0 0 zc(2) 0],'color','r');
              line([xc(1) xc(2)],[yc(1) yc(2)],[zc(1) zc(2)],'color','k','LineWidth',2);
     hold off
    text(0,0,-3,'CAMERA A'); text(c-c/5,0,-3,'CAMERA B'); 
      text(xcref+30,ycref+40, 0,'Reference')
      text(xc(1)-20,yc(1)+40, zc(1),'C1')
      text(xc(2)+30,yc(2)+0, zc(2),'C2')
      title(['REAL DATA PROCESSING - Distance: ',num2str(Dist)])
    grid on; box on
